<?php 
/* 
 * 	   Copyright 2010 WALTHER Jrmy & MOLE Bruno
 *    Zoku Server
 *    Version 1.0-beta
 *    
 *    Contact the authors :
 *    WALTHER Jrmy	: jeremy.walther@ftad.fr
 *    MOLE Bruno		: bruno.mole@ftad.fr
 *    
 *    This file is part of Zoku Server.
 *
 *    Zoku Server is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Zoku Server is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Zoku Server.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
?>
<?php

class ZS_User extends ZS_Base
{
	public $id = -1;
	public $username = "";
	public $password = "";
	public $email = "";
	public $admin = -1;
	public $last_ip = "";
	public $last_dns = "";
	public $create_date = 0;
	public $last_date = 0;
	
	
	function __construct($row = "")
	{
		parent::__construct();
		if ($row != "")
		{
			$this->createFromArray($row);
		}
	}
	
	
	public function createFromArray($array)
	{
		if (isset($array['id']))			{ $this->id = $array['id']; };
		if (isset($array['username']))		{ $this->username = $array['username']; };
		if (isset($array['password']))		{ $this->password = $array['password']; };
		if (isset($array['email']))			{ $this->email = $array['email']; };
		if (isset($array['admin']))			{ $this->admin = $array['admin']; };
		if (isset($array['last_ip']))		{ $this->last_ip = $array['last_ip']; };
		if (isset($array['last_dns']))		{ $this->last_dns = $array['last_dns']; };
		if (isset($array['last_date']))		{ $this->last_date = $array['last_date']; };
		if (isset($array['create_date']))	{ $this->create_date = $array['create_date']; };
		return true;
	}
	
	
	public function selectById($id)
	{
		if ($result = $this->getDBLink()->query("SELECT * FROM `".$this->getDBPrefix()."_card` WHERE `id` = '$id'"))
		{
			if($row = $this->getDBLink()->fetch($result))
			{
				return $this->createFromArray($row);
			}
		}
		return false;
	}

	public function getVars()
	{
		return get_object_vars($this);
	}
	
	public function getGroupId()
	{
		if ($result = $this->getDBLink()->query("SELECT `group_id` FROM `".$this->getDBPrefix()."_card` WHERE `id` = '$this->id'"))
		{
			if($group = $this->getDBLink()->result($result))
			{
				return $group;
			}
		}
	}
	
	public function setGroupId($group)
	{
		return $this->getDBLink()->query("UPDATE `".$this->getDBPrefix()."_card` SET `group_id` = '$group' WHERE `id` = '$this->id'");
	}
	
	public function getAdmin()
	{
		return zs_adminIntToArray($this->admin);
	}
	
	public function setAdmin($admin)
	{
		$this->admin = zs_adminArrayToInt($admin);
		return $this->getDBLink()->query("UPDATE `".$this->getDBPrefix()."_card` SET `admin` = '$this->admin' WHERE `id` = '$this->id'");
	}
	
	public function hashPassword()
	{
		$this->password = sha1($this->password);
	}
	
	public function updateLog()
	{
		return $this->getDBLink()->query("UPDATE `".$this->getDBPrefix()."_card` SET `last_ip` = '".$_SERVER['REMOTE_ADDR']."', `last_dns` = '".gethostbyaddr($_SERVER['REMOTE_ADDR'])."', `last_date` = '".time()."' WHERE `id` = '$this->id'");
	}
}

?>