-- phpMyAdmin SQL Dump
-- version 3.2.0.1
-- http://www.phpmyadmin.net
--
-- Serveur: localhost
-- Gnr le : Dim 23 Mai 2010  18:22
-- Version du serveur: 5.1.36
-- Version de PHP: 5.3.0

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Base de donnes: `zoku`
--

-- --------------------------------------------------------

--
-- Structure de la table `zoku_card`
--

DROP TABLE IF EXISTS `zoku_card`;
CREATE TABLE IF NOT EXISTS `zoku_card` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `key` varchar(60) NOT NULL,
  `username` varchar(60) NOT NULL,
  `password` varchar(60) NOT NULL,
  `email` varchar(255) NOT NULL,
  `first_name` varchar(60) NOT NULL,
  `last_name` varchar(60) NOT NULL,
  `birthdate` varchar(10) NOT NULL,
  `gender` varchar(10) NOT NULL,
  `phone` varchar(60) DEFAULT NULL,
  `address` varchar(255) DEFAULT NULL,
  `city` varchar(60) DEFAULT NULL,
  `zipcode` varchar(60) DEFAULT NULL,
  `country` varchar(60) DEFAULT NULL,
  `photo` varchar(255) DEFAULT NULL,
  `website` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `type` varchar(255) NOT NULL,
  `group_id` int(10) unsigned NOT NULL,
  `other` text,
  `admin` tinyint(3) unsigned NOT NULL,
  `last_ip` varchar(60) DEFAULT NULL,
  `last_dns` varchar(60) DEFAULT NULL,
  `last_date` int(10) NOT NULL,
  `create_date` int(10) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `key` (`key`),
  KEY `group_id` (`group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Contenu de la table `zoku_card`
--


-- --------------------------------------------------------

--
-- Structure de la table `zoku_event`
--

DROP TABLE IF EXISTS `zoku_event`;
CREATE TABLE IF NOT EXISTS `zoku_event` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `type` varchar(255) NOT NULL,
  `starting_date` int(10) unsigned NOT NULL,
  `ending_date` int(10) unsigned NOT NULL,
  `address` varchar(255) NOT NULL,
  `city` varchar(60) NOT NULL,
  `zipcode` varchar(60) NOT NULL,
  `country` varchar(60) NOT NULL,
  `email` varchar(255) NOT NULL,
  `phone` varchar(60) NOT NULL,
  `website` varchar(255) NOT NULL,
  `logo` varchar(255) DEFAULT NULL,
  `url` varchar(255) NOT NULL,
  `group_id` int(10) unsigned NOT NULL,
  `min_people` int(10) unsigned NOT NULL,
  `max_people` int(10) unsigned NOT NULL,
  `fees` int(10) unsigned NOT NULL,
  `create_date` int(10) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `group_id` (`group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Contenu de la table `zoku_event`
--


-- --------------------------------------------------------

--
-- Structure de la table `zoku_eventmember`
--

DROP TABLE IF EXISTS `zoku_eventmember`;
CREATE TABLE IF NOT EXISTS `zoku_eventmember` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `event_id` int(10) unsigned NOT NULL,
  `card_id` int(10) unsigned NOT NULL,
  `controller_id` int(10) unsigned NOT NULL,
  `date` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `event_id` (`event_id`),
  KEY `card_id` (`card_id`),
  KEY `controller_id` (`controller_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Contenu de la table `zoku_eventmember`
--


-- --------------------------------------------------------

--
-- Structure de la table `zoku_keystoric`
--

DROP TABLE IF EXISTS `zoku_keystoric`;
CREATE TABLE IF NOT EXISTS `zoku_keystoric` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `key` varchar(60) NOT NULL,
  `card_id` int(10) unsigned NOT NULL,
  `create_date` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

--
-- Contenu de la table `zoku_eventmember`
--


-- --------------------------------------------------------

--
-- Structure de la table `zoku_group`
--

DROP TABLE IF EXISTS `zoku_group`;
CREATE TABLE IF NOT EXISTS `zoku_group` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(60) NOT NULL,
  `acronym` varchar(60) NOT NULL,
  `email` varchar(255) NOT NULL,
  `phone` varchar(60) NOT NULL,
  `address` varchar(60) NOT NULL,
  `city` varchar(60) NOT NULL,
  `zipcode` varchar(60) NOT NULL,
  `country` varchar(60) NOT NULL,
  `logo` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `type` varchar(255) NOT NULL,
  `website` varchar(255) DEFAULT NULL,
  `supergroup_id` int(10) unsigned NOT NULL,
  `owner_id` int(10) unsigned NOT NULL,
  `create_date` int(10) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `supergroup_id` (`supergroup_id`),
  KEY `owner_id` (`owner_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;



-- dummy data
-- password = azerty

INSERT INTO `zoku_card` 
(`key`, `username`, `password`, `email`, `first_name`, `last_name`, `birthdate`, `gender`, `phone`, `address`, `city`, `zipcode`, `country`, `photo`, `website`, `url`, `type`, `group_id`, `other`, `admin`, `last_ip`, `last_dns`, `last_date`, `create_date`) 
VALUES 
('X1', 'user1', 'ab4f63f9ac65152575886860dde480a1', 'user1@test.fr', 'USER1', 'User1', '01/01/1901', 'Mr', '', '', '', '', '', '', '', '', 'Type1', '0', '', '0', '', '', '', ''),
('X2', 'user2', 'ab4f63f9ac65152575886860dde480a1', 'user2@test.fr', 'USER2', 'User2', '01/01/1902', 'Mme','', '', '', '', '', '', '', '', 'Type2', '0', '', '0', '', '', '', ''),
('X3', 'user3', 'ab4f63f9ac65152575886860dde480a1', 'user3@test.fr', 'USER3', 'User3', '01/01/1903', 'Mlle','', '', '', '', '', '', '', '', 'Type3', '0', '', '0', '', '', '', ''),
('X4', 'user4', 'ab4f63f9ac65152575886860dde480a1', 'user4@test.fr', 'USER4', 'User4', '01/01/1904', 'Mr','', '', '', '', '', '', '', '', 'Type4', '0', '', '0', '', '', '', ''),
('X5', 'user5', 'ab4f63f9ac65152575886860dde480a1', 'user5@test.fr', 'USER5', 'User5', '01/01/1905', 'Mme','', '', '', '', '', '', '', '', 'Type5', '0', '', '0', '', '', '', ''),
('X6', 'user6', 'ab4f63f9ac65152575886860dde480a1', 'user6@test.fr', 'USER6', 'User6', '01/01/1906', 'Mlle','', '', '', '', '', '', '', '', 'Type6', '0', '', '0', '', '', '', ''),
('X7', 'user7', 'ab4f63f9ac65152575886860dde480a1', 'user7@test.fr', 'USER7', 'User7', '01/01/1907', 'Mr','', '', '', '', '', '', '', '', 'Type7', '0', '', '0', '', '', '', '');

INSERT INTO `zoku_group` 
(`name`, `acronym`, `email`, `phone`, `address`, `city`, `zipcode`, `country`, `logo`, `url`, `website`, `type`, `supergroup_id`, `owner_id`, `create_date`) 
VALUES 
('group1', 'gp1', 'gp1@test.fr', '', '', '', '', '', '', '', '', 'Type1', '0', '0', ''),
('group2', 'gp2', 'gp2@test.fr', '', '', '', '', '', '', '', '', 'Type2', '0', '0', ''),
('sans association', 'gp0', 'gp0@test.fr', '', '', '', '', '', '', '', '', 'Type0', '0', '0', '');

UPDATE `zoku_group` SET `id` = '0' WHERE `id` = '3';




-- Contraintes pour la table `zoku_card`
--
--ALTER TABLE `zoku_card`
--ADD CONSTRAINT `zoku_card_ibfk_1` FOREIGN KEY (`group_id`) REFERENCES `zoku_group` (`id`);


-- Contraintes pour la table `zoku_event`
--
--ALTER TABLE `zoku_event`
--ADD CONSTRAINT `zoku_event_ibfk_1` FOREIGN KEY (`group_id`) REFERENCES `zoku_group` (`id`);


-- Contraintes pour la table `zoku_eventmember`
--
--ALTER TABLE `zoku_eventmember`
--ADD CONSTRAINT `zoku_eventmember_ibfk_3` FOREIGN KEY (`controller_id`) REFERENCES `zoku_card` (`id`),
--ADD CONSTRAINT `zoku_eventmember_ibfk_1` FOREIGN KEY (`event_id`) REFERENCES `zoku_event` (`id`),
--ADD CONSTRAINT `zoku_eventmember_ibfk_2` FOREIGN KEY (`card_id`) REFERENCES `zoku_card` (`id`);


-- Contraintes pour la table `zoku_group`
--
--ALTER TABLE `zoku_group`
--ADD CONSTRAINT `zoku_group_ibfk_2` FOREIGN KEY (`owner_id`) REFERENCES `zoku_card` (`id`),
--ADD CONSTRAINT `zoku_group_ibfk_1` FOREIGN KEY (`supergroup_id`) REFERENCES `zoku_group` (`id`);